/* Copyright 2020, Michele Santullo
 * This file is part of memoserv.
 *
 * Memoserv is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Memoserv is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Memoserv.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "animation_with_size.hpp"

namespace duck {
	AnimationWithSize::AnimationWithSize (nana::size sz, std::size_t fps) :
		nana::animation(),
		m_size(sz)
	{
		this->fps(fps);
	}

	AnimationWithSize::AnimationWithSize (AnimationWithSize&& other) :
		nana::animation(std::move(other)),
		m_size(std::move(other.m_size))
	{
	}

	AnimationWithSize::~AnimationWithSize() noexcept = default;

	AnimationWithSize& AnimationWithSize::operator= (AnimationWithSize&& other) {
		m_size = std::move(other.m_size);
		*static_cast<nana::animation*>(this) = std::move(other);
		return *this;
	}
} //namespace duck
