/* Copyright 2020, Michele Santullo
 * This file is part of memoserv.
 *
 * Memoserv is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Memoserv is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Memoserv.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include <nana/gui/animation.hpp>

namespace duck {
	class AnimationWithSize : public nana::animation {
	public:
		explicit AnimationWithSize (nana::size sz, std::size_t fps = 23);
		AnimationWithSize (AnimationWithSize&& other);

		AnimationWithSize& operator= (AnimationWithSize&& other);
		~AnimationWithSize() noexcept;

		const nana::size& size() const { return m_size; }

	private:
		nana::size m_size;
	};
} //namespace duck
