/* Copyright 2020, Michele Santullo
 * This file is part of memoserv.
 *
 * Memoserv is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Memoserv is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Memoserv.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include <cstdint>

namespace mc::psx {
template <bool Const> class BasicFrame;
using ConstFrame = BasicFrame<true>;

enum class BlockContent : uint8_t {
	Available = 0xA0,
	UsedLinkNextBlock = 0x51,
	UsedMidLink = 0x52,
	UsedEndLink = 0x53,
	Unusable = 0xff
};

struct ContentInfo {
	ContentInfo (const ConstFrame& frame);

	uint32_t use_byte;
	uint16_t magic;
	BlockContent available_blocks;

	static const constexpr uint16_t MCMagic = 'M' | ('C' << 8);
	static const constexpr uint16_t SCMagic = 'S' | ('C' << 8);
};
} //namespace mc::psx
