/* Copyright 2020, Michele Santullo
 * This file is part of memoserv.
 *
 * Memoserv is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Memoserv is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Memoserv.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include <string>

namespace mc::psx {
enum class CountryCode : uint16_t {
	Japan = 'B' | ('I' << 8),
	America = 'B' | ('A' << 8),
	Europe = 'B' | ('E' << 8),
	Unknown = 0
};

std::string to_string (CountryCode code);
char to_char (CountryCode code);
uint16_t to_uint16 (CountryCode code);
CountryCode to_country_code (uint16_t code);
} //namespace mc::psx
