/* Copyright 2020, Michele Santullo
 * This file is part of memoserv.
 *
 * Memoserv is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Memoserv is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Memoserv.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "memcard/country_code.hpp"

namespace mc::psx {
std::string to_string (CountryCode code) {
	switch (code) {
	case CountryCode::Japan: return "Japan";
	case CountryCode::America: return "America";
	case CountryCode::Europe: return "Europe";
	default: return "Unknown";
	};
}

char to_char (CountryCode code) {
	switch (code) {
	case CountryCode::Japan: return 'J';
	case CountryCode::America: return 'U';
	case CountryCode::Europe: return 'E';
	default: return 'X';
	};
}

uint16_t to_uint16 (CountryCode code) {
	return static_cast<uint16_t>(code);
}

CountryCode to_country_code (uint16_t code) {
	switch (code) {
	case static_cast<uint16_t>(CountryCode::Japan): return CountryCode::Japan;
	case static_cast<uint16_t>(CountryCode::America): return CountryCode::America;
	case static_cast<uint16_t>(CountryCode::Europe): return CountryCode::Europe;
	default: return CountryCode::Unknown;
	}
}
} //namespace mc::psx
