/* Copyright 2020, Michele Santullo
 * This file is part of memoserv.
 *
 * Memoserv is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Memoserv is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Memoserv.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "memcard/frame.hpp"
#include <cassert>

namespace mc::psx {
template <bool Const>
BasicFrame<Const>::BasicFrame (data_type* data, std::size_t index) :
	m_index(index),
	m_data(data)
{
}

template <bool Const>
auto BasicFrame<Const>::operator[] (std::size_t index) -> data_type& {
	assert(index < size());
	return m_data[index];
}

template <bool Const>
auto BasicFrame<Const>::operator[] (std::size_t index) const -> const data_type& {
	assert(index < size());
	return m_data[index];
}

template class BasicFrame<true>;
template class BasicFrame<false>;
} //namespace mc::psx
