/* Copyright 2020, Michele Santullo
 * This file is part of memoserv.
 *
 * Memoserv is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Memoserv is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Memoserv.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "memcard/make_memory_card.hpp"
#include <iterator>
#include <fstream>

namespace mc::psx {
MemoryCard make_memory_card(std::istream&& raw_mc) {
	raw_mc >> std::noskipws;

	return MemoryCard{
		std::istream_iterator<uint8_t>(raw_mc),
		std::istream_iterator<uint8_t>(),
	};
}

MemoryCard make_memory_card(const std::string& path) {
	return make_memory_card(std::ifstream(path, std::ios::binary));
}
} //namespace mc::psx
